// MailslotDlg.cpp : t@C
//

#include "stdafx.h"
#include "Mailslot.h"
#include "MailslotDlg.h"
#include ".\mailslotdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMailslotDlg _CAO



CMailslotDlg::CMailslotDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CMailslotDlg::IDD, pParent)
{

    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    TCHAR tszMyComputer[MAX_COMPUTERNAME_LENGTH + 1];// l̃T[o[
    DWORD dwMyComputerSize = sizeof(tszMyComputer);
    GetComputerName(tszMyComputer, &dwMyComputerSize);
    m_szComputerName = tszMyComputer;

    TCHAR tszUserName[UNLEN + 1];// s[U[
    DWORD dwUserNameSize = sizeof(tszUserName);
    GetUserName(tszUserName, &dwUserNameSize);
    m_szUserName = tszUserName;

    m_szMessage = "";// bZ[W
}

void CMailslotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDITMESSAGE, m_szMessage);
	DDV_MaxChars(pDX, m_szMessage, 256);
	DDX_Text(pDX, IDC_EDITSERVER, m_szComputerName);
	DDV_MaxChars(pDX, m_szComputerName, 256);
}

BEGIN_MESSAGE_MAP(CMailslotDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTONSEND, OnBnClickedButtonsend)
END_MESSAGE_MAP()


// CMailslotDlg bZ[W nh

BOOL CMailslotDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    m_hMailSlot = CreateMailslot(// [XbgT[o[N
            _T("\\\\.\\mailslot\\MailSlotSample"), 0, 5000, NULL);
    if(m_hMailSlot == INVALID_HANDLE_VALUE){
        CString text;
        text.Format(_T("CreateMailslot code = %d"), GetLastError());
        MessageBox(text);
        return FALSE;
    }

    SetTimer(1, 1000, NULL);// ^C}[ݒ

    SetIcon(m_hIcon, TRUE);
    SetIcon(m_hIcon, FALSE);

    GotoDlgCtrl(GetDlgItem(IDC_EDITMESSAGE));// bZ[W͈ɁAtH[JXړ

    return FALSE;
}


void CMailslotDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CMailslotDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CMailslotDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMailslotDlg::OnDestroy()
{
	CDialog::OnDestroy();

    KillTimer(1);

    if(m_hMailSlot != INVALID_HANDLE_VALUE){
        CloseHandle(m_hMailSlot);
}
}
void CMailslotDlg::ReceiveMessage(void)
{
    TCHAR szMessage[1024];
    DWORD dwReaded;
    BOOL fSuccess = ReadFile(m_hMailSlot,
            szMessage, sizeof(szMessage)-1, &dwReaded, NULL);
    if(fSuccess == FALSE){
        LRESULT lResult = GetLastError();
        if((lResult==ERROR_ACCESS_DENIED)||(lResult==ERROR_SEM_TIMEOUT)){
            return;
        }
        CString text;
        text.Format(_T("ReadFile code = %d"), GetLastError());
        MessageBox(text);
        return;
    }

    SYSTEMTIME stime;// Xgɒǉ
    GetLocalTime(&stime);
    CString buff;
    LPTSTR lptszUser = strtok(szMessage, "\n");
    LPTSTR lptszData = strtok(NULL, "\n");
    buff.Format("%04d/%02d/%02d %02d:%02d:%02d %s/%s",
            stime.wYear, stime.wMonth, stime.wDay,
            stime.wHour, stime.wMinute, stime.wSecond,
            lptszUser ? lptszUser : _T("[IDs]"), 
            lptszData ? lptszData : _T("[bZ[WȂ]"));
    CListBox *pList = (CListBox*)GetDlgItem(IDC_LISTMESSAGE);
    pList->AddString(buff);
}


void CMailslotDlg::OnTimer(UINT nIDEvent)
{
	DWORD    dwNextSize, dwMessageCount;// bZ[WM`FbN

    BOOL fSuccess = GetMailslotInfo(m_hMailSlot,
            NULL, &dwNextSize, &dwMessageCount, NULL);
    if(fSuccess == FALSE){
        CString text;
        text.Format(_T("GetMailslotInfo code = %d"), GetLastError());
        MessageBox(text);
        return;
    }
    if(dwNextSize == MAILSLOT_NO_MESSAGE){
        return;
    }

    for(DWORD dwCount = 0; dwCount < dwMessageCount; dwCount++){// bZ[WM
        ReceiveMessage();
    }

}

void CMailslotDlg::OnBnClickedButtonsend()
{
	GetDlgItemText(IDC_EDITSERVER,  m_szComputerName);// OK{^Ȃ̂Ŏ͂Œl擾
    GetDlgItemText(IDC_EDITMESSAGE, m_szMessage);

    CString path;
    path.Format(_T("\\\\%s\\mailslot\\MailSlotSample"), m_szComputerName);
    HANDLE hFile = CreateFile(path,
            GENERIC_WRITE, FILE_SHARE_WRITE | FILE_SHARE_READ,
            NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if(hFile == INVALID_HANDLE_VALUE){
        CString text;
        text.Format(_T("CreateFile code = %d"), GetLastError());
        MessageBox(text);
        return;
    }

    LPTSTR lptszBuff = new TCHAR[1024];// M
    DWORD dwBuffSize = wsprintf(lptszBuff, _T("%s\n%s\n"), m_szUserName, m_szMessage);
    DWORD dwWritted;
    BOOL fSuccess = WriteFile(hFile, lptszBuff, dwBuffSize+1, &dwWritted, NULL);
    if(fSuccess == FALSE){
        CString text;
        text.Format(_T("WriteFile code = %d"), GetLastError());
        MessageBox(text);
    }

    CloseHandle(hFile);
    delete lptszBuff;
}
