// WinHTTPClientDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinHTTPClient.h"
#include "WinHTTPClientDlg.h"
#include ".\winhttpclientdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CWinHTTPClientDlg _CAO



CWinHTTPClientDlg::CWinHTTPClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinHTTPClientDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinHTTPClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDITURL, m_editURL);
	DDX_Control(pDX, IDC_EDITHEADER, m_editHeader);
	DDX_Control(pDX, IDC_EDITHTML, m_editHtml);
	DDX_Control(pDX, ID_REQUEST, m_buttonRequest);
}

BEGIN_MESSAGE_MAP(CWinHTTPClientDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_REQUEST, OnBnClickedRequest)
END_MESSAGE_MAP()


// CWinHTTPClientDlg bZ[W nh

BOOL CWinHTTPClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	GotoDlgCtrl(&m_editURL); //

    return FALSE;//܂ŏC
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CWinHTTPClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CWinHTTPClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CWinHTTPClientDlg::OnBnClickedRequest()
{
	CWinHttpRequest http;
    CString url, header, body;

    m_buttonRequest.EnableWindow(FALSE);
    m_editURL.GetWindowText(url);

    CComVariant vtEmpty, vtAsync;
    V_VT(&vtEmpty)   = VT_ERROR;
    V_VT(&vtAsync)   = VT_BOOL;
    V_BOOL(&vtAsync) = VARIANT_FALSE;

    if(http.CreateDispatch(_T("WinHttp.WinHttpRequest.5.1")) == FALSE){
        MessageBox("WinHTTP Failed");
        return;
    }
    http.Open(_T("GET"), url, vtAsync);
    http.Send(vtEmpty);
    header = http.GetAllResponseHeaders();

    long lDimension;
    CComVariant vtBody = http.get_ResponseBody();
    if((vtBody.vt == (VT_UI1 | VT_ARRAY))
     &&((lDimension = SafeArrayGetDim(vtBody.parray)) == 1)){
        //f[^擾
        long lUpper, lLower;
        LPSTR lpszSafe;
        SafeArrayGetLBound(vtBody.parray, 1, &lLower);
        SafeArrayGetUBound(vtBody.parray, 1, &lUpper);
        SafeArrayAccessData (vtBody.parray, (void**)&lpszSafe);
        body = CString(lpszSafe, (lUpper - lLower + 1));
        SafeArrayUnaccessData(vtBody.parray);
    }
    else{
        //R[hϊꂽ擾
        body = http.get_ResponseText();
    }

    m_editHeader.SetWindowText(header);
    m_editHtml.SetWindowText(body);
    m_buttonRequest.EnableWindow(TRUE);
	
}
