// WinInetFTPClientDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinInetFTPClient.h"
#include "WinInetFTPClientDlg.h"
#include ".\wininetftpclientdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CWinInetFTPClientDlg _CAO



CWinInetFTPClientDlg::CWinInetFTPClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinInetFTPClientDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinInetFTPClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDITSERVER, m_editServer);
	DDX_Control(pDX, IDC_EDITUSER, m_editUser);
	DDX_Control(pDX, IDCANCEL, m_editPassword);
	DDX_Control(pDX, IDC_EDITFILE, m_editFile);
	DDX_Control(pDX, IDC_EDITDIR, m_editDir);
	DDX_Control(pDX, IDC_CHECKPASV, m_checkPASV);
	DDX_Control(pDX, ID_EXEC, m_buttonExec);
	DDX_Control(pDX, IDC_RADIOGET, m_radioGet);
}

BEGIN_MESSAGE_MAP(CWinInetFTPClientDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_EXEC, OnBnClickedExec)
END_MESSAGE_MAP()


// CWinInetFTPClientDlg bZ[W nh

BOOL CWinInetFTPClientDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    SetIcon(m_hIcon, TRUE);
    SetIcon(m_hIcon, FALSE);

    m_radioGet.SetCheck(BST_CHECKED);//
    GotoDlgCtrl(&m_editServer);//܂Œǉ

    return FALSE;//C
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CWinInetFTPClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CWinInetFTPClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


LRESULT CWinInetFTPClientDlg::GetRemoteFile(
CFtpConnection *pConn, CString& szRemoteFile, CString& szLocalFile)
{
    CString text;
    LRESULT lResult = ERROR_SUCCESS;

    try{// ɑ݂ꍇ́AIɃl[
        CFile::Remove(szLocalFile + ".bak");
    }
    catch(CFileException *e){
        e->Delete();
    }
    try{
        CFile::Rename(szLocalFile, szLocalFile + ".bak");
    }
    catch(CFileException *e){
        e->Delete();
    }

    if(pConn->GetFile(szRemoteFile, szLocalFile) == FALSE){
        throw new CInternetException(GetLastError());
    }
    MessageBox(_T("Mɐ܂B"), NULL, MB_ICONINFORMATION | MB_OK);

    return lResult;
}

LRESULT CWinInetFTPClientDlg::PutLocalFile(
CFtpConnection *pConn, CString& szLocalFile, CString& szRemoteFile)
{
    LRESULT lResult = ERROR_SUCCESS;

    if(pConn->PutFile(szRemoteFile, szLocalFile) == FALSE){
        throw new CInternetException(GetLastError());
    }

    MessageBox(_T("Abv[hɐ܂B"), NULL, MB_ICONINFORMATION | MB_OK);
    return lResult;
}


void CWinInetFTPClientDlg::OnBnClickedExec()
{
	CString szServerName;
    CString szUserName, szPassword;
    CString szCurrentDir, szRemoteFile, szLocalFile;

    m_editServer.GetWindowText(szServerName);
    m_editUser.GetWindowText(szUserName);
    m_editPassword.GetWindowText(szPassword);
    m_editDir.GetWindowText(szCurrentDir);
    m_editFile.GetWindowText(szRemoteFile);
    szLocalFile = szRemoteFile;
	int    iMode = ModeGET;
    if(m_radioGet.GetCheck() == BST_UNCHECKED){
        iMode = ModePUT;
    }
    BOOL fPASV = FALSE;
    if(m_checkPASV.GetCheck() == BST_CHECKED){
        fPASV = TRUE;
    }
m_buttonExec.EnableWindow(FALSE);//

    CInternetSession session("SampleWinInetFTP");
    CFtpConnection    *pConn = NULL;

    try{
        pConn = session.GetFtpConnection(szServerName,
            szUserName, szPassword, INTERNET_INVALID_PORT_NUMBER, fPASV);

        if(szCurrentDir.IsEmpty() == FALSE){
            if(pConn->SetCurrentDirectory(szCurrentDir) == FALSE){
                throw new CInternetException(GetLastError());
            }
        }
        if(iMode == ModeGET){
            GetRemoteFile(pConn, szRemoteFile, szLocalFile);
        }
        else{
            PutLocalFile(pConn, szLocalFile, szRemoteFile);
        }
    }
    catch(CInternetException *e){
        TCHAR szMessage[256];
        UINT nContext = 0;
        e->GetErrorMessage(szMessage, sizeof(szMessage)-1, &nContext);
        MessageBox(szMessage);
        e->Delete();
    }

    if(pConn != NULL){
        pConn->Close();
        delete pConn;
    }
    session.Close();

    m_buttonExec.EnableWindow(TRUE);//܂Œǉ
}
