// WinInetHTTPClientDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinInetHTTPClient.h"
#include "WinInetHTTPClientDlg.h"
#include ".\wininethttpclientdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CWinInetHTTPClientDlg _CAO



CWinInetHTTPClientDlg::CWinInetHTTPClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinInetHTTPClientDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinInetHTTPClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDITURL, m_editURL);
	DDX_Control(pDX, IDC_EDITHEADER, m_editHeader);
	DDX_Control(pDX, IDC_EDITHTML, m_editHtml);
	DDX_Control(pDX, IDC_REQUEST, m_buttonRequest);
}

BEGIN_MESSAGE_MAP(CWinInetHTTPClientDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_REQUEST, OnBnClickedRequest)
END_MESSAGE_MAP()


// CWinInetHTTPClientDlg bZ[W nh

BOOL CWinInetHTTPClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	GotoDlgCtrl(&m_editURL);//ǉFURL͈ɃtH[JXݒ肷

    return FALSE;//C
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CWinInetHTTPClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CWinInetHTTPClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CWinInetHTTPClientDlg::OnBnClickedRequest()
{
	CString szURL;
    m_editURL.GetWindowText(szURL);

    CString          szServerName;
    CString          szObject;
    DWORD            dwServiceType;
    INTERNET_PORT    nPort;

    if(AfxParseURL(szURL, dwServiceType, szServerName//
                   , szObject, nPort)== FALSE){
        MessageBox(_T("URL̏܂B"));
        return;
}
	if((dwServiceType != AFX_INET_SERVICE_HTTP)//
    &&(dwServiceType != AFX_INET_SERVICE_HTTPS)){
        MessageBox(_T("ΉĂȂvgRłB"));
        return;
	}//܂Œǉ
	DWORD dwFlags = INTERNET_FLAG_RELOAD //
                  | INTERNET_FLAG_NO_CACHE_WRITE
                  | INTERNET_FLAG_KEEP_CONNECTION;
    if(dwServiceType == AFX_INET_SERVICE_HTTPS){
        dwFlags |= INTERNET_FLAG_SECURE;
    } //܂Œǉ
CInternetSession    session(_T("SampleWinInetHTTP"));//
    CHttpConnection     *pServer = NULL;
    CHttpFile           *pFile   = NULL;//܂Œǉ

    m_buttonRequest.EnableWindow(FALSE);//ǉ

	try{//
        pServer = session.GetHttpConnection(szServerName, dwFlags, nPort);
		pFile = pServer->OpenRequest(CHttpConnection::HTTP_VERB_GET,//
                    szObject, NULL, 1, NULL, _T("HTTP/1.1"), dwFlags);
		pFile->SendRequest();//ǉ
DWORD dwStatus;//
        pFile->QueryInfoStatusCode(dwStatus);

        while(dwStatus == HTTP_STATUS_DENIED){// F؂Kv
            DWORD dwPrompt;
            dwPrompt = pFile->ErrorDlg(NULL, ERROR_INTERNET_INCORRECT_PASSWORD,
            FLAGS_ERROR_UI_FLAGS_GENERATE_DATA
            |FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS, NULL);
            if(dwPrompt != ERROR_INTERNET_FORCE_RETRY){
                break;    // LZꂽ
            }
            pFile->SendRequest();
            pFile->QueryInfoStatusCode(dwStatus);
        }//܂Œǉ
        CString szHeaders;//wb_[̎擾Aǉ
        pFile->QueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF, szHeaders);
        m_editHeader.SetWindowText(szHeaders);

        CString szHtmls;//{fB̎擾
        TCHAR   szBuff[1024];
        while(UINT nRead = pFile->Read(szBuff, sizeof(szBuff)-1)){
            *(szBuff+nRead) = '\0';
            szHtmls.Append(szBuff);
        }
        m_editHtml.SetWindowText(szHtmls);//܂Œǉ
    }
    catch(CInternetException *e){
	TCHAR szMessage[256];//ǉ
        UINT nContext = 0;
        e->GetErrorMessage(szMessage, sizeof(szMessage)-1, &nContext);
        MessageBox(szMessage);
        e->Delete();//܂Œǉ
	}//܂ŏC

   if(pFile != NULL){//ǉ
        pFile->Close();
        delete pFile;
    }
    if(pServer != NULL){
        pServer->Close();
        delete pServer;
    }
    session.Close();
    m_buttonRequest.EnableWindow(TRUE);//܂Œǉ
}