#ifndef WINVER
#define WINVER 0x0400
#endif
#include <afxwin.h>

// CEBhENX
class CWorkerThreadWnd : public CFrameWnd
{
public:
    CWorkerThreadWnd()
    {
        Create(NULL, _T("[J[XbheXgAvP[V"));
    }
    DECLARE_MESSAGE_MAP()
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
};

// AvP[VNX
class CWorkerThreadApp : public CWinApp
{
public: 
    BOOL InitInstance()
    {
        m_pMainWnd = new CWorkerThreadWnd();
        m_pMainWnd->ShowWindow(m_nCmdShow);
        m_pMainWnd->UpdateWindow();
        return TRUE;
    }
};

// bZ[W}bv
BEGIN_MESSAGE_MAP(CWorkerThreadWnd, CFrameWnd)
    ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

// CX^X𐶐
CWorkerThreadApp app;


//[J[Xbhp̃p[^
class CThreadParams
{
public:
    CThreadParams(CWorkerThreadWnd *pWnd, CPoint &point)
    {
        m_pWnd = pWnd;
        m_point = point;
    }
    CWorkerThreadWnd *m_pWnd;
    CPoint m_point;
};

UINT WorkerThread(LPVOID lpvParam)
{
    CThreadParams *pParams = (CThreadParams*)lpvParam;
    CPoint point = pParams->m_point;
    CClientDC dc(pParams->m_pWnd);
    delete pParams;

    CBrush    drawBrush, clearBlush;
    CPen    drawPen, clearPen;

    // uV
    drawBrush.CreateSolidBrush(RGB(100,100,255));
    clearBlush.CreateSolidBrush(RGB(255,255,255));
    // y
    drawPen.CreatePen(PS_SOLID, 4, RGB(255,100,100));
    clearPen.CreatePen(PS_SOLID, 4, RGB(255,255,255));

    int y = point.y;
    for(int x = point.x; x >= 0; x -= 35){
        int iWait = x;    // XW҂Ԃɂ
        dc.SelectObject(&drawBrush);
        dc.SelectObject(&drawPen);
        dc.Ellipse(x, y, x+30, y+30);
        Sleep(iWait);
        dc.SelectObject(&clearBlush);
        dc.SelectObject(&clearPen);
        dc.Ellipse(x, y, x+30, y+30);
    }
    return 0;
}

void CWorkerThreadWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
    CThreadParams *pParams = new CThreadParams(this, point);
    AfxBeginThread(WorkerThread, (LPVOID)pParams);

    CFrameWnd::OnLButtonDown(nFlags, point);
}
